<template>
  <div style="width: 100%">
    <BasicTable @register="registerTable" @fetch-success="onFetchSuccess" :searchInfo="searchInfo">
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'action'">
          <TableAction
            :actions="[
              {
                label: '阅读',
                onClick: handleDetail.bind(null, record),
              },
            ]"
          />
        </template>
      </template>
    </BasicTable>
    <a-modal
      width="100%"
      wrap-class-name="full-modal"
      v-model:open="auditOpen"
      title="阅读"
      :destroyOnClose="true"
    >
      <template #footer> </template>
      <Audit
        ref="posRef"
        :processId="processId"
        :taskId="taskId"
        :isRead="isRead"
        :type="type"
        @closeModel="closeMolder"
      />
    </a-modal>
  </div>
</template>

<script lang="ts" setup>
  import { reactive, h, ref } from 'vue';
  import { BasicTable, useTable, TableAction } from '@/components/Table';
  import { getLoadMyReadPage } from '@/api/sys/WFTask';
  import { Tag } from 'ant-design-vue';
  import { Audit } from './process/page';

  const searchInfo = reactive<Recordable>({});
  const processId = ref('');
  const taskId = ref('');
  const isRead: any = ref(0);
  const type = ref('');
  const auditOpen = ref(false);
  const [registerTable, { reload }] = useTable({
    api: getLoadMyReadPage,
    columns: [
      {
        title: '任务',
        dataIndex: 'unitName',
      },
      {
        title: '标题',
        dataIndex: 'processTitle',
      },
      {
        title: '状态',
        dataIndex: 'state',
        width: 80,
        customRender: ({ record }) => {
          if (record.state == '1') {
            const color = 'red';
            const text = '未阅';
            return h(Tag, { color: color }, () => text);
          } else {
            const color = 'green';
            const text = '已阅';
            return h(Tag, { color: color }, () => text);
          }
        },
      },
      {
        title: '提交人',
        dataIndex: 'processUserName',
      },
      {
        title: '创建时间',
        dataIndex: 'createDate',
      },
    ],
    rowKey: 'id',
    formConfig: {
      labelWidth: 120,
      schemas: [
        {
          field: '[StartDate, EndDate]',
          label: '日期范围',
          component: 'RangePicker',
          componentProps: {
            format: 'YYYY-MM-DD',
            placeholder: ['开始日期', '结束日期'],
          },
          colProps: { span: 8 },
        },
        {
          field: 'keyWord',
          label: '关键字',
          component: 'Input',
          colProps: { span: 8 },
        },
      ],
    },
    useSearchForm: true,
    showTableSetting: true,
    bordered: true,
    handleSearchInfoFn(info) {
      return info;
    },
    actionColumn: {
      width: 100,
      title: '操作',
      dataIndex: 'action',
      // slots: { customRender: 'action' },
    },
  });
  function handleDetail(record) {
    let isread;
    if (record.state == 1) {
      isread = 1;
    } else {
      isread = 0;
    }
    auditOpen.value = true;
    processId.value = record.processId;
    taskId.value = record.id;
    type.value = record.type;
    isRead.value = isread;
    // go('/dashboard/task_audit_preview/detail?processId=' + record.processId+"&taskId="+record.id+"&type="+record.type+"&isRead="+isRead);
  }
  function closeMolder() {
    auditOpen.value = false;
    reload();
  }
</script>
<style lang="less">
  .full-modal {
    .ant-modal {
      max-width: 100%;
      top: 0;
    }

    .ant-modal-content {
      height: calc(100vh);
    }

    .ant-modal-body {
      height: 85%;
    }
  }
</style>
